; ================================================================================ 
;   darius/src/boss1.asm                                                           
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;                                                            
; ---------------------------------------------------------------- 
BOSS1_INI:
	MOV	<SPR_BANK0, #BANK_BOSS1_SPR0
	MOV	<SPR_BANK1, #BANK_BOSS1_SPR1

	; dˁE
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY0
	TSK_CHG	TASK_BOSS_OVERLAY0,               .TASK_OVERLAY
	MOV	TASK_BOSS_OVERLAY0+TCB_HIT_TYPE,  #BOSS1_HIT_BODY
	MOV	TASK_BOSS_OVERLAY0+TCB_ACT,       #BOSS1_TBL_FRAME
	MOV	TASK_BOSS_OVERLAY0+TCB_PAT_COUNT, BOSS1_TBL_COUNT+BOSS1_TBL_FRAME
	MOV	TASK_BOSS_OVERLAY0+TCB_PAT,       BOSS1_TBL_PAT  +BOSS1_TBL_FRAME

	; G
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY1
	TSK_CHG	TASK_BOSS_OVERLAY1,               .TASK_TENTACLES
	MOV	TASK_BOSS_OVERLAY1+TCB_ACT,       #BOSS1_TBL_OPEN
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT_COUNT, BOSS1_TBL_COUNT+BOSS1_TBL_OPEN
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT,       BOSS1_TBL_PAT  +BOSS1_TBL_OPEN
	MOV	<BOSS_BANK0,                      BOSS1_TBL_PARAM+BOSS1_TBL_OPEN
	TAY
	INY
	STY	<BOSS_BANK1
	RTS


; ---------------------------------------------------------------- 
;   Jn                                                           
; ---------------------------------------------------------------- 
BOSS1_START:
	; {
	TSK_CHG	TASK_BOSS, .TASK_BODY
	MOV	TASK_BOSS+TCB_SPEED, #2

	; dˁE
	TSK_CHG	TASK_BOSS_OVERLAY0, .TASK_OVERLAY_100

	; G
	TSK_CHG	TASK_BOSS_OVERLAY1, .TASK_TENTACLES_100

	; 
	ADD_TASK_QUE	#TASK_BOSS_OVERLAY2
	TSK_CHG	TASK_BOSS_OVERLAY2,              .TASK_MOUTH
	MOV	TASK_BOSS_OVERLAY2+TCB_XPOS_L,   #56
	MOV	TASK_BOSS_OVERLAY2+TCB_YPOS_L,   #80
	MOV	TASK_BOSS_OVERLAY2+TCB_HIT,      #0
	MOV	TASK_BOSS_OVERLAY2+TCB_HIT_TYPE, #BOSS1_HIT_MOUTH
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT0,   #0
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT1,   #30
	RTS


; ---------------------------------------------------------------- 
;   oNݒ肠ANV                                       
; ---------------------------------------------------------------- 
.ACT_BANK:
	DEC	TCB_PAT_COUNT,X
	BPL	.ACT_BANK_080

	INC	TCB_ACT,X
	LDY	TCB_ACT,X

	LDA	BOSS0_TBL_COUNT,Y
	BEQ	.ACT_BANK_0F0

	STA	TCB_PAT_COUNT,X

	MOV	TCB_PAT,X, BOSS1_TBL_PAT,Y

	MOV	<BOSS_BANK0, BOSS1_TBL_PARAM,Y
	TAY
	INY
	STY	<BOSS_BANK1

.ACT_BANK_080:
	CLC
	RTS

.ACT_BANK_0F0:
	SEC
	RTS


; ---------------------------------------------------------------- 
;   oNݒȂANV                                       
; ---------------------------------------------------------------- 
.ACT_NOBANK:
	DEC	TCB_PAT_COUNT,X
	BPL	.ACT_NOBANK_080

	INC	TCB_ACT,X
	LDY	TCB_ACT,X

	LDA	BOSS0_TBL_COUNT,Y
	BMI	.ACT_NOBANK_0F0

	STA	TCB_PAT_COUNT,X

	MOV	TCB_PAT,X, BOSS0_TBL_PAT,Y

.ACT_NOBANK_080:
	CLC
	RTS

.ACT_NOBANK_0F0:
	CLC
	ADC	TCB_ACT,X
	STA	TCB_ACT,X
	TAY
	MOV	TCB_PAT_COUNT,X, BOSS0_TBL_COUNT,Y
	MOV	TCB_PAT,X,       BOSS0_TBL_PAT,Y

	SEC
	RTS


; ---------------------------------------------------------------- 
;   {̃^XN                                                 
; ---------------------------------------------------------------- 
.TASK_BODY:
	MOV	TASK_BOSS+TCB_COUNT0, #4
	MOV	TASK_BOSS+TCB_COUNT1, #3

; ------------------------------------------------ 
;   ㉺ړ                                       
; ------------------------------------------------ 
.TASK_BODY_100:
	TSK_CHG	TASK_BOSS, .TASK_BODY_140
	MOV	TASK_BOSS+TCB_ANGLE, #192

.TASK_BODY_140:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	TASK_BOSS+TCB_YPOS_H
	BPL	@F

	MOV	TASK_BOSS+TCB_YPOS_H, #0
	STA	TASK_BOSS+TCB_YPOS_L

	TSK_CHG	TASK_BOSS, .TASK_BODY_180
	MOV	TASK_BOSS+TCB_ANGLE, #64
@@:
	TSK_RET


.TASK_BODY_180:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	#48
	CMP	TASK_BOSS+TCB_YPOS_L
	BCS	@F

	DEC	TASK_BOSS+TCB_COUNT1
	BEQ	.TASK_BODY_200

	TSK_CHG	TASK_BOSS, .TASK_BODY_140
	MOV	TASK_BOSS+TCB_ANGLE, #192
@@:
	TSK_RET


; ------------------------------------------------ 
;   Oړ                                         
; ------------------------------------------------ 
.TASK_BODY_200:
	DEC	TASK_BOSS+TCB_COUNT0
	BEQ	.TASK_BODY_300

	TSK_CHG	TASK_BOSS, .TASK_BODY_240
	MOV	TASK_BOSS+TCB_ANGLE, #182
	TSK_RET

.TASK_BODY_240:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	TASK_BOSS+TCB_YPOS_H
	BPL	@F

	MOV	TASK_BOSS+TCB_YPOS_H, #0
	STA	TASK_BOSS+TCB_YPOS_L

	TSK_CHG	TASK_BOSS, .TASK_BODY_280
	MOV	TASK_BOSS+TCB_ANGLE, #74
@@:
	TSK_RET


.TASK_BODY_280:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	#48
	CMP	TASK_BOSS+TCB_YPOS_L
	BCS	@F

	TSK_CHG	TASK_BOSS, .TASK_BODY_100
	MOV	TASK_BOSS+TCB_ANGLE,  #192
	MOV	TASK_BOSS+TCB_COUNT1, #2
@@:
	TSK_RET


; ------------------------------------------------ 
;   ړ                                         
; ------------------------------------------------ 
.TASK_BODY_300:
	TSK_CHG	TASK_BOSS, .TASK_BODY_340
	MOV	TASK_BOSS+TCB_ANGLE, #192+27
	TSK_RET

.TASK_BODY_340:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	TASK_BOSS+TCB_YPOS_H
	BPL	@F

	MOV	TASK_BOSS+TCB_YPOS_H, #0
	STA	TASK_BOSS+TCB_YPOS_L

	TSK_CHG	TASK_BOSS, .TASK_BODY_380
	MOV	TASK_BOSS+TCB_ANGLE, #64-26
@@:
	TSK_RET


.TASK_BODY_380:
	ADD_TASK_QUE

	JSR	MOVE_ANGLE
	JSR	SET_BOSS_POS

	LDA	#48
	CMP	TASK_BOSS+TCB_YPOS_L
	BCS	@F

	TSK_CHG	TASK_BOSS, .TASK_BODY_100
	MOV	TASK_BOSS+TCB_ANGLE,  #192
	MOV	TASK_BOSS+TCB_COUNT0, #4
	MOV	TASK_BOSS+TCB_COUNT1, #2
@@:
	TSK_RET




; ---------------------------------------------------------------- 
;   d˃^XN                                                 
; ---------------------------------------------------------------- 
.TASK_OVERLAY:
	ADD_TASK_QUE

	LDA	<TICK_COUNT
	LSR	A
	BCC	@F

	LDY	#BOSS1_PAT_BASE
	JSR	SET_BOSS_SPR_BUFF
@@:
	TSK_RET


.TASK_OVERLAY_100:
	ADD_TASK_QUE

	JSR	ADD_BOSS_HIT_QUE

	JSR	.ACT_NOBANK

	LDA	<TICK_COUNT
	LSR	A
	BCC	@F

	LDY	#BOSS1_PAT_BASE
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET

@@:
	LDY	TCB_PAT+TASK_BOSS_OVERLAY0
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET


; ---------------------------------------------------------------- 
;   G^XN                                                 
; ---------------------------------------------------------------- 
.TASK_TENTACLES:
	ADD_TASK_QUE

	LDY	TASK_BOSS_OVERLAY1+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET


.TASK_TENTACLES_100:
	ADD_TASK_QUE

	JSR	.ACT_BANK
	BCS	@F

	LDY	TASK_BOSS_OVERLAY1+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET

@@:
	TSK_CHG	TASK_BOSS_OVERLAY1, .TASK_TENTACLES_200

	MOV	<BOSS_BANK0, #BANK_BOSS1_BODY0
	MOV	<BOSS_BANK1, #BANK_BOSS1_BODY1
	MOV	<SPR_BANK1,  #BANK_BOSS1_SPR3

	MOV	TASK_BOSS_OVERLAY1+TCB_ACT,       #BOSS1_TBL_EXPLOSION
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT_COUNT, BOSS1_TBL_COUNT+BOSS1_TBL_EXPLOSION
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT,       BOSS1_TBL_PAT  +BOSS1_TBL_EXPLOSION

	; j[heij쐬
	MOV	<TEMP+0, #(128+16)
	MOV	<TEMP+1, #10
	MOV	<TEMP+2, #0
	STA	<TEMP+4

	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#48
	STA	<TEMP+3

	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#26
	STA	<TEMP+5
	JSR	CRE_NEEDLE_BULLET

	; j[heij쐬
	MOV	<TEMP+0, #(128+16)
	MOV	<TEMP+1, #10
	MOV	<TEMP+2, #0
	STA	<TEMP+4

	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#12
	STA	<TEMP+3

	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#129
	STA	<TEMP+5
	JSR	CRE_NEEDLE_BULLET

	; j[heij쐬
	MOV	<TEMP+0, #(128+16)
	MOV	<TEMP+1, #10
	MOV	<TEMP+2, #0
	STA	<TEMP+4

	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#6
	STA	<TEMP+3

	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#81
	STA	<TEMP+5
	JSR	CRE_NEEDLE_BULLET

	; j[heiEj쐬
	MOV	<TEMP+0, #(128+16)
	MOV	<TEMP+1, #10
	MOV	<TEMP+2, #0
	STA	<TEMP+4

	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#89
	STA	<TEMP+3

	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#65
	STA	<TEMP+5
	JSR	CRE_NEEDLE_BULLET

	TSK_RET


.TASK_TENTACLES_200:
	ADD_TASK_QUE

	JSR	.ACT_NOBANK
	BCS	.TASK_TENTACLES_2F0

	LDA	<TICK_COUNT
	LSR	A
	BCS	@F

	LDY	TASK_BOSS_OVERLAY1+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET
@@:
	LDY	#BOSS0_PAT_TENTACLES0
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET


.TASK_TENTACLES_2F0:
	TSK_CHG	TASK_BOSS_OVERLAY1,            .TASK_TENTACLES_300
	MOV	TASK_BOSS_OVERLAY1+TCB_COUNT0, #32

	LDY	TASK_BOSS_OVERLAY1+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF

	TSK_RET


.TASK_TENTACLES_300:
	ADD_TASK_QUE

	DEC	TASK_BOSS_OVERLAY1+TCB_COUNT0
	BNE	@F

	TSK_CHG	TASK_BOSS_OVERLAY1,               .TASK_TENTACLES_100
	MOV	TASK_BOSS_OVERLAY1+TCB_ACT,       #BOSS1_TBL_REOPEN
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT_COUNT, BOSS1_TBL_COUNT+BOSS1_TBL_REOPEN
	MOV	TASK_BOSS_OVERLAY1+TCB_PAT,       BOSS1_TBL_PAT  +BOSS1_TBL_REOPEN
	MOV	<BOSS_BANK0,                      BOSS1_TBL_PARAM+BOSS1_TBL_REOPEN
	TAY
	INY
	STY	<BOSS_BANK1
	MOV	<SPR_BANK1, #BANK_BOSS1_SPR1

	LDY	TASK_BOSS_OVERLAY1+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET

@@:
	LDY	#BOSS0_PAT_TENTACLES0
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET


; ---------------------------------------------------------------- 
;   ^XN                                                   
; ---------------------------------------------------------------- 
.MOUTH_COMMON:
	ADD_TASK_QUE

	LDA	TASK_BOSS_OVERLAY2+TCB_HIT
	BEQ	@F

	MOV	TASK_BOSS_OVERLAY2+TCB_HIT, #0

	; 쐬
	JSR	CRE_EXPLOSION
@@:
	JSR	ADD_BOSS_HIT_QUE
	RTS


.TASK_MOUTH:
	ADD_TASK_QUE

	DEC	TASK_BOSS_OVERLAY2+TCB_COUNT1
	BNE	@F

	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT1, #16

	; p^[ԍXV
	INC	TASK_BOSS_OVERLAY2+TCB_COUNT0
	LDA	#2
	CMP	TASK_BOSS_OVERLAY2+TCB_COUNT0
	BCC	.TASK_MOUTH_0F0

	; 
	LDX	TASK_BOSS_OVERLAY2+TCB_COUNT0
	LDY	<VRAM_PROC_COUNT
	INC	<VRAM_PROC_COUNT
	LDA	.WBG_MOUTH_PROC_H,X
	STA	VRAM_PROC_BUFF_H,Y
	LDA	.WBG_MOUTH_PROC_L,X
	STA	VRAM_PROC_BUFF_L,Y
@@:
	TSK_RET


.TASK_MOUTH_0F0:
	TSK_CHG	TASK_BOSS_OVERLAY2,            .TASK_MOUTH_100
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT0, #3
	TSK_RET


; ------------------------------------------------ 
;   [U[                                   
; ------------------------------------------------ 
.TASK_MOUTH_100:
	JSR	.MOUTH_COMMON

	TSK_CHG	TASK_BOSS_OVERLAY2,               .TASK_MOUTH_140
	MOV	TASK_BOSS_OVERLAY2+TCB_ACT,       #BOSS1_TBL_ATTACK
	MOV	TASK_BOSS_OVERLAY2+TCB_PAT_COUNT, BOSS1_TBL_COUNT+BOSS1_TBL_ATTACK
	MOV	TASK_BOSS_OVERLAY2+TCB_PAT,       BOSS1_TBL_PAT  +BOSS1_TBL_ATTACK

	; [U[^XN쐬
	MOV	<TEMP+0, #4
	MOV	<TEMP+1, #0
	STA	<TEMP+3

	LDA	TCB_XPOS_L+TASK_BOSS
	ADD	#56
	STA	<TEMP+2

	LDA	TCB_YPOS_L+TASK_BOSS
	ADD	#76
	STA	<TEMP+4
	JSR	CRE_LASER0

	TSK_RET


.TASK_MOUTH_140:
	JSR	.MOUTH_COMMON

	JSR	.ACT_NOBANK
	BCS	@F

	LDY	TASK_BOSS_OVERLAY2+TCB_PAT
	JSR	SET_BOSS_SPR_BUFF
	TSK_RET

@@:
	TSK_CHG	TASK_BOSS_OVERLAY2, .TASK_MOUTH_180
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT1, #20
	TSK_RET


.TASK_MOUTH_180:
	JSR	.MOUTH_COMMON

	DEC	TASK_BOSS_OVERLAY2+TCB_COUNT1
	BNE	@F

	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT1, #20

	DEC	TASK_BOSS_OVERLAY2+TCB_COUNT0
	BEQ	.TASK_MOUTH_1C0

	TSK_CHG	TASK_BOSS_OVERLAY2, .TASK_MOUTH_100
@@:
	TSK_RET


.TASK_MOUTH_1C0:
	TSK_CHG	TASK_BOSS_OVERLAY2, .TASK_MOUTH_200
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT0, #30

	; 
	VRAM_PROC_ADD	BOSS1_WBG_MOUTH0_PROC
	TSK_RET


; ------------------------------------------------ 
;   ҂                                           
; ------------------------------------------------ 
.TASK_MOUTH_200:
	JSR	.MOUTH_COMMON

	DEC	TASK_BOSS_OVERLAY2+TCB_COUNT0
	BEQ	@F

	TSK_RET

@@:
	TSK_CHG	TASK_BOSS_OVERLAY2,            .TASK_MOUTH
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT0, #0
	MOV	TASK_BOSS_OVERLAY2+TCB_COUNT1, #30
	TSK_RET




.WBG_MOUTH_PROC_H	.DB	HIGH(BOSS1_WBG_MOUTH0_PROC), HIGH(BOSS1_WBG_MOUTH1_PROC), HIGH(BOSS1_WBG_MOUTH2_PROC)
.WBG_MOUTH_PROC_L	.DB	 LOW(BOSS1_WBG_MOUTH0_PROC),  LOW(BOSS1_WBG_MOUTH1_PROC),  LOW(BOSS1_WBG_MOUTH2_PROC)
