; ================================================================================ 
;   darius/src/common.asm                                                          
;                                                                                  
;   Copyright (C) 2017 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.CODE

; ---------------------------------------------------------------- 
;   VBLANK ҂                                                    
;                                                                  
;   IN   : Ȃ                                                    
;   OUT  : Ȃ                                                    
;   BREAK: A                                                       
; ---------------------------------------------------------------- 
WAIT_VBLANK:
	MOV	PPU_REG_CTRL1, #0
	STA	PPU_REG_CTRL2
@@:
	LDA	PPU_REG_STATUS
	BPL	@B
	RTS


; ---------------------------------------------------------------- 
;   pbgf[^                                       
;                                                                  
;   IN   : A = AhX                                            
;          Y = pbgCfbNX                                
;   OUT  : Ȃ                                                    
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
WRITE_PAL_DATA:
	MOV_X	PPU_REG_VRAM_ADDR, #HIGH(PPU_BGPAL)
	STA	PPU_REG_VRAM_ADDR
	MOV	PPU_REG_VRAM_DATA, COL_DATA0,Y
	MOV	PPU_REG_VRAM_DATA, COL_DATA1,Y
	MOV	PPU_REG_VRAM_DATA, COL_DATA2,Y
	MOV	PPU_REG_VRAM_DATA, COL_DATA3,Y
	RTS


; ---------------------------------------------------------------- 
;   VRAM f[^փpbgf[^ݒ                              
;                                                                  
;   IN   : A = AhX                                            
;          Y = pbgCfbNX                                
;   OUT  : Ȃ                                                    
;   BREAK: A, X, TEMP+0                                            
; ---------------------------------------------------------------- 
SET_PAL_DATA:
	STX	<TEMP+0

	LDX	<VRAM_DATA_COUNT
	STA	VRAM_DATA_BUFF+VRAM_L,X
	MOV	VRAM_DATA_BUFF+VRAM_H,X,      #HIGH($3F00)
	MOV	VRAM_DATA_BUFF+VRAM_COUNT,X,  #3
	MOV	VRAM_DATA_BUFF+VRAM_DATA+0,X, COL_DATA1,Y
	MOV	VRAM_DATA_BUFF+VRAM_DATA+1,X, COL_DATA2,Y
	MOV	VRAM_DATA_BUFF+VRAM_DATA+2,X, COL_DATA3,Y
	TXA
	ADD	#6
	STA	<VRAM_DATA_COUNT

	LDX	<TEMP+0
	RTS


; ---------------------------------------------------------------- 
;   _Z                                                       
;                                                                  
;   IN   : A = _                                                
;          X =                                                   
;   OUT  : X = s^XNԍ                                      
;   BREAK: A, X                                                    
; ---------------------------------------------------------------- 
ADD_SCORE:
	ADD	<SCORE,X
	BCC	.ADD_SCORE_000

	ADD	#-10
	STA	<SCORE,X
@@:
	DEX
	INC	<SCORE,X
	BNE	.ADD_SCORE_080

	MOV	<SCORE,X, #-10
	JMP	@B


.ADD_SCORE_000:
	STA	<SCORE,X

.ADD_SCORE_080:
	TXA
	CMP	<UPDATE_SCORE
	BCS	@F

	STA	<UPDATE_SCORE
@@:
	LDX	<TASK_RUN
	RTS


; ---------------------------------------------------------------- 
;   px擾                                                     
;                                                                  
;   IN   : X = ^XN                                              
;          Y = ڕW^XN                                          
;   OUT  : A = px                                                
;   BREAK: A, Y, TEMP+0                                            
; ---------------------------------------------------------------- 
GET_ANGLE:
	LDA	TCB_XPOS_L,Y
	SUB	TCB_XPOS_L,X
	BCC	.GET_ANGLE_080

	; TEMP+0 = (TCB_XPOS[Y] - TCB_XPOS[X]) / 16
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	STA	<TEMP+0

	LDA	TCB_YPOS_L,Y
	SUB	TCB_YPOS_L,X
	BCC	@F

	; E
	AND	#~15
	ORA	<TEMP+0
	TAY
	LDA	ANGLE_DATA,Y
	RTS
@@:
	; E
	LDA	TCB_YPOS_L,X
	SUB	TCB_YPOS_L,Y
	AND	#~15
	ORA	<TEMP+0
	TAY
	LDA	#0
	SUB	ANGLE_DATA,Y
	RTS


.GET_ANGLE_080:
	; TEMP+0 = (TCB_XPOS[X] - TCB_XPOS[Y]) / 16
	LDA	TCB_XPOS_L,X
	SUB	TCB_XPOS_L,Y
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	STA	<TEMP+0

	LDA	TCB_YPOS_L,Y
	SUB	TCB_YPOS_L,X
	BCC	@F

	; 
	AND	#~15
	ORA	<TEMP+0
	TAY
	LDA	#128
	SUB	ANGLE_DATA,Y
	RTS

@@:
	; 
	LDA	TCB_YPOS_L,X
	SUB	TCB_YPOS_L,Y
	AND	#~15
	ORA	<TEMP+0
	TAY
	LDA	#128
	ADD	ANGLE_DATA,Y
	RTS


; ---------------------------------------------------------------- 
;   pẍړ                                                     
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, Y                                                    
; ---------------------------------------------------------------- 
MOVE_ANGLE:
.MOVE_ANGLE_X:
	; -------------------------------- 
	;                            
	; -------------------------------- 
	; TCB_SPEED * SIN_DATA[TCB_ANGLE+64]
	MOV	MMC5_MUL_L, TCB_SPEED,X

	LDA	TCB_ANGLE,X
	ADD	#64
	TAY
	LDA	SIN_DATA,Y
	BMI	.MOVE_ANGLE_XSUB

.MOVE_ANGLE_XADD:
	STA	MMC5_MUL_H

	; TCB_XPOS += MMC5_MUL
	LDA	TCB_XPOS_F,X
	ADD	MMC5_MUL_L
	STA	TCB_XPOS_F,X
	LDA	TCB_XPOS_L,X
	ADC	MMC5_MUL_H
	STA	TCB_XPOS_L,X
	BCC	.MOVE_ANGLE_Y

	INC	TCB_XPOS_H,X
	JMP	.MOVE_ANGLE_Y

.MOVE_ANGLE_XSUB:
	AND	#$7F
	STA	MMC5_MUL_H

	; TCB_XPOS -= MMC5_MUL
	LDA	TCB_XPOS_F,X
	SUB	MMC5_MUL_L
	STA	TCB_XPOS_F,X
	LDA	TCB_XPOS_L,X
	SBC	MMC5_MUL_H
	STA	TCB_XPOS_L,X
	BCS	.MOVE_ANGLE_Y

	DEC	TCB_XPOS_H,X

	; -------------------------------- 
	;                            
	; -------------------------------- 
.MOVE_ANGLE_Y:
	; TCB_SPEED * SIN_DATA[TCB_ANGLE]
	MOV	MMC5_MUL_L, TCB_SPEED,X

	LDY	TCB_ANGLE,X
	LDA	SIN_DATA,Y
	BMI	.MOVE_ANGLE_YSUB

.MOVE_ANGLE_YADD:
	STA	MMC5_MUL_H

	; TCB_YPOS += MMC5_MUL
	LDA	TCB_YPOS_F,X
	ADD	MMC5_MUL_L
	STA	TCB_YPOS_F,X
	LDA	TCB_YPOS_L,X
	ADC	MMC5_MUL_H
	STA	TCB_YPOS_L,X
	BCC	.MOVE_ANGLE_0F0

	INC	TCB_YPOS_H,X
	RTS

.MOVE_ANGLE_YSUB:
	AND	#$7F
	STA	MMC5_MUL_H

	; TCB_YPOS -= MMC5_MUL
	LDA	TCB_YPOS_F,X
	SUB	MMC5_MUL_L
	STA	TCB_YPOS_F,X
	LDA	TCB_YPOS_L,X
	SBC	MMC5_MUL_H
	STA	TCB_YPOS_L,X
	BCS	.MOVE_ANGLE_0F0

	DEC	TCB_YPOS_H,X

.MOVE_ANGLE_0F0:
	RTS


; ---------------------------------------------------------------- 
;   ANV                                                     
;                                                                  
;   IN   : X                  = ^XNԍ                         
;   OUT  : L[tOȂ = ANVI                   
;          L[tO = ANVI                     
;   BREAK: A, Y, TEMP+0                                            
; ---------------------------------------------------------------- 
ACT_TASK:
	DEC	TCB_PAT_COUNT,X
	BNE	@F

	INC	TCB_ACT,X
	LDY	TCB_ACT,X

	LDA	COMM_TBL_COUNT,Y
	BMI	SET_ACT_LOOP

	; ̃ANV
	STA	TCB_PAT_COUNT,X
	MOV	TCB_HIT_TYPE,X, COMM_TBL_PARAM,Y
	MOV	TCB_PAT,X,      COMM_TBL_PAT,Y
@@:
	CLC
	RTS


; ---------------------------------------------------------------- 
;   ANVݒ                                               
;                                                                  
;   IN   : A = ANVԍ                                      
;          X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, Y, TEMP+0                                            
; ---------------------------------------------------------------- 
SET_ACT_LOOP:
	ADD	TCB_ACT,X
SET_ACT:
	STA	TCB_ACT,X
	TAY
	MOV	TCB_PAT_COUNT,X, COMM_TBL_COUNT,Y
	MOV	TCB_HIT_TYPE,X,  COMM_TBL_PARAM,Y
	MOV	TCB_PAT,X,       COMM_TBL_PAT,Y
	SEC
	RTS


; ---------------------------------------------------------------- 
;   XvCgobt@֐ݒ                                       
;                                                                  
;   IN   : X = ^XNԍ                                          
;   OUT  : Ȃ                                                    
;   BREAK: A, Y, TEMP+0                                            
; ---------------------------------------------------------------- 
SET_SPR_BUFF:
	; ʊOȂ疳
	LDA	TCB_XPOS_H,X
	ORA	TCB_YPOS_H,X
	BNE	.SET_SPR_BUFF_F00

	LDA	TCB_PAT,X
	TAY

.SET_SPR_BUFF_000:
	; W
	LDA	COMM_PAT_XOFS,Y
	BMI	@F

	; Z
	ADD	TCB_XPOS_L,X
	BCS	.SET_SPR_BUFF_300
	JMP	.SET_SPR_BUFF_0F0
@@:
	; Z
	ADD	TCB_XPOS_L,X
	BCC	.SET_SPR_BUFF_300

.SET_SPR_BUFF_0F0:
	STA	<TEMP+0


.SET_SPR_BUFF_100:
	; W
	LDA	COMM_PAT_YOFS,Y
	BMI	@F

	; Z
	ADD	TCB_YPOS_L,X
	BCS	.SET_SPR_BUFF_300
	JMP	.SET_SPR_BUFF_200
@@:
	; Z
	ADD	TCB_YPOS_L,X
	BCC	.SET_SPR_BUFF_200


.SET_SPR_BUFF_200:
	ADD	#23
	BCS	.SET_SPR_BUFF_300

	LDX	<SPR_BUFF_W

	STA	SPR_BUFF+SPR_YPOS,X
	MOV	SPR_BUFF+SPR_XPOS,X, <TEMP+0
	MOV	SPR_BUFF+SPR_PAT,X,  COMM_PAT_NO,Y
	LDA	COMM_PAT_ATTR,Y
	ORA	<SPR_EXT_ATTR
	STA	SPR_BUFF+SPR_ATTR,X
	ADD_X	#4
	STX	<SPR_BUFF_W

.SET_SPR_BUFF_240:
	INY
	LDX	<TASK_RUN

	AND	#$04
	BEQ	.SET_SPR_BUFF_000
.SET_SPR_BUFF_F00:
	RTS


.SET_SPR_BUFF_300:
	LDA	COMM_PAT_ATTR,Y
	JMP	.SET_SPR_BUFF_240


; -------------------------------------------------------------------------------- 
;   XvCgobt@֐ݒi{Xpj                                             
;                                                                                  
;   IN   : Y = p^[ԍ                                                        
;   OUT  : Ȃ                                                                    
;   BREAK: A, Y, TEMP+0                                                            
; -------------------------------------------------------------------------------- 
SET_BOSS_SPR_BUFF:
	; ʊOȂ疳
	LDA	TCB_XPOS_H+TASK_BOSS
	ORA	TCB_YPOS_H+TASK_BOSS
	BNE	.SET_SPR_BUFF_F00

	STX	<TEMP
	LDX	<SPR_BUFF_W

.SET_BOSS_SPR_BUFF_000:
	; W
	LDA	BOSS0_PAT_XOFS,Y
	ADD	TCB_XPOS_L+TASK_BOSS
	BCS	.SET_BOSS_SPR_BUFF_100
	STA	SPR_BUFF+SPR_XPOS,X

	; W
	LDA	BOSS0_PAT_YOFS,Y
	ADD	TCB_YPOS_L+TASK_BOSS
	BCS	.SET_BOSS_SPR_BUFF_100
	STA	SPR_BUFF+SPR_YPOS,X

	ADD	#23
	BCS	.SET_BOSS_SPR_BUFF_100

	STA	SPR_BUFF+SPR_YPOS,X
	MOV	SPR_BUFF+SPR_PAT,X,  BOSS0_PAT_NO,Y
	MOV	SPR_BUFF+SPR_ATTR,X, BOSS0_PAT_ATTR,Y
	ADD_X	#4

.SET_BOSS_SPR_BUFF_040:
	INY

	AND	#$04
	BEQ	.SET_BOSS_SPR_BUFF_000

	STX	<SPR_BUFF_W
	LDX	<TEMP
	RTS


.SET_BOSS_SPR_BUFF_100:
	LDA	BOSS0_PAT_ATTR,Y
	JMP	.SET_BOSS_SPR_BUFF_040


; ------------------------------------------------ 
;   O                                     
; ------------------------------------------------ 
PRE_IGNORE:
	PRE_RET


; ------------------------------------------------ 
;   ㏈                                     
; ------------------------------------------------ 
POST_IGNORE:
	POST_RET
